<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <div class="container"></div>
    <script>
        // let req = new XMLHttpRequest;
        // req.open('GET', 'https://swapi.dev/api/films/');
        // req.responseType = 'json'
        // req.send();
        // req.onload = function () {
        //     if (req.status >= 300) {
        //         console.log(`error: ${req.status} ${req.statusText}`);
        //     }
        //     else {
        //         const result = req.response.results
        //         result.forEach(({ title, characters, episode_id, opening_crawl }) => {
        //             const container = document.querySelector('.container')
        //             const filmList = document.createElement('ul')
        //             let charactersList = []
        //             characters.forEach(item => {
        //                 let newReq = new XMLHttpRequest
        //                 newReq.open('GET', item)
        //                 newReq.responseType = 'json'
        //                 newReq.send();
        //                 newReq.onload = function () {
        //                     if (newReq.status >= 300) {
        //                         console.log(`error: ${newReq.status} ${newReq.statusText}`);
        //                     }
        //                     else {
        //                         const name = newReq.response.name;
        //                         charactersList.push(`<li>${name}</li>`)
        //                         filmList.innerHTML = `<li>Film title : ${title}</li>
        //                                 <li>Episode : ${episode_id}</li>
        //                                 <li>Opening crawl : ${opening_crawl}</li>
        //                                 <li>Characters :
        //                                     <ul>${charactersList.join('')}</ul>
        //                                     </li>`
        //                         container.append(filmList)
        //                     }
        //                 }
        //             })
        //         })
        //     }
        // }




        const request = sendGetRequest('https://swapi.dev/api/films/')
        request.then(({ results }) => {
            results.forEach(({ title, characters, episode_id, opening_crawl }) => {

                const container = document.querySelector('.container')
                const filmList = document.createElement('ul')
                let charactersList = []
                characters.forEach(item => {
                    const charactersReq = sendGetRequest(item)
                    charactersReq.then(({ name }) => {
                        charactersList.push(`<li>${name}</li>`)
                        filmList.innerHTML = `<li>Film title : ${title}</li>
                                        <li>Episode : ${episode_id}</li>
                                        <li>Opening crawl : ${opening_crawl}</li>
                                        <li>Characters :
                                           <ul>${charactersList.join('')}</ul>
                                           </li>`
                        container.append(filmList)
                    }).catch(error => {
                        console.log(error);
                    });
                })
            })
        }).catch(error => {
            console.log(error);
        });

        function sendGetRequest(url) {
            const answer = new Promise(function (resolve, reject) {
                const request = new XMLHttpRequest();
                request.open('GET', url)
                request.responseType = 'json'
                request.send();
                request.onload = function () {
                    if (request.status < 300) {
                        resolve(request.response);
                    } else {
                        reject(request.statusText);
                    }
                }
            })
            return answer
        }
    </script>
</body>

</html>